{

6502 core test env.  08

Configured for 80Mhz HYDRA.  Nothing requires this however, so edit for your setup.  (Done in TV Driver)

All that's provided here right now is a STRING compatable font, Text Display Driver, Screen Buffer, Pointers to things

Getting ready for ASM 6502.

Moved code and various data bits into their own SPIN
files and added pointer setup to make stuff easy.

Staying with partial 6502 for now.  Gotta do some speed tests and figure out how best to encode and optimize instructions!


}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYDRA
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

VAR
  word          displayb             'pointer to display buffer
  word          r6502_program        'pointer to 6502 program to be executed
  word          fonttab              'pointer to HUB Font Table

  
VAR
  long          params[4]            'parameter block for the TV driver                       
                '[0] screen memory                           
                '[1] font table
                '[2] pix_mode not yet implemented...
                '[3] colors, or 16 bit mode = $00
VAR
  long          index                'just an index...     

  
OBJ
  tv    : "8x8_NTSC_40x24_TV-hydra"                     'the actual TV display driver
  font  : "Font_ATARI"                                  'a font table!  Actually, this uses the AIGeneric system for font files!
  'cpu   : "spud6502_03"                                'partial 6502 in SPIN for concept testing
  cpu : "spud_asm_6502_08"                              'PASM partial 6502!
  code  : "r6502_executable_03"                         '6502 executable code
  
 
PUB start

    init_pointers
    init_display
    clear_screen

    print_xy(4,1, @welcome)                             'Let somebody know what the heck is going on!
    print_xy(11,5, @label1)

    byte [$7e00] [80] := $a9                            'This is a test value, for comparison to debug values
    
{we do stuff here with the emulated CPU...}

    cpu.execute(r6502_program)                          'fire off the 6502
    


PUB  init_pointers
     displayb := $7bff                                  'locate display memory at top of HUB
     r6502_program := code.GetPointerTo6502Program      'fetch pointer to executable code


     
PUB  init_display
     params[0] := displayb                               'HUB Address of Text Display Buffer
     params[1] := font.GetPtrToFontTable                 'HUB Address of font table used by TV display  (ASCII)
     params[2] := $0000_0000                             'Not implemented....  
     params[3] := $0000704                               'Text display colors (Black and White default)

     tv.start(@params)                                   'start the tv cog & pass it the parameter block
      
PUB  clear_screen | c
     c := 32
     repeat index from 0 to 1024
        byte [displayb] [index] := c                     'clear the screen


PRI  print_xy (x, y, str_addr) | i
     'brutally simple print routine
     'no clipping, no wrap around, no formatting, no nothing
     i := 0
     i := i + x + (y * 40)
     bytemove (displayb + i, str_addr, strsize(str_addr))

    

DAT

Welcome  Byte "6502 Testing in Progress...", 0
Label1   Byte "<--- 6502 in PASM...", 0










   